diff --git a/nxdrive/direct_transfer/uploader.py b/nxdrive/direct_transfer/uploader.py
new file mode 100644
index 000000000..b6f1f7151
--- /dev/null
+++ b/nxdrive/direct_transfer/uploader.py
@@ -0,0 +1,287 @@
+# coding: utf-8
+"""
+The Direct Transfer feature.
+
+What: upload methods and exceptions.
+"""
+from logging import getLogger
+from pathlib import Path
+from typing import TYPE_CHECKING, Any, Optional
+
+from nuxeo.exceptions import HTTPError
+from nuxeo.handlers.default import Uploader
+from nuxeo.models import Document, FileBlob
+
+from ..constants import TX_TIMEOUT, TransferStatus
+from ..options import Options
+from .models import Transfer
+
+if TYPE_CHECKING:
+    from ..client.remote_client import Remote  # noqa
+
+log = getLogger(__name__)
+
+
+class DirectTransferPaused(Exception):
+    """A transfer has been paused, the file's processing should stop."""
+
+
+class DirectTransferDuplicateFoundError(ValueError):
+    """
+    Exception raised when a duplicate file already exists on the server
+    and trying to Direct Transfer a local file with the same name.
+    """
+
+    def __init__(self, file: Path, doc: Document) -> None:
+        self.file = file
+        self.doc = doc
+
+    def __repr__(self) -> str:
+        return f"{type(self).__name__}<file={self.file!r}, doc={self.doc!r}>"
+
+    def __str__(self) -> str:
+        return (
+            f"Document with the name {self.file.name!r} already found on the server: {self.doc}."
+            f"Direct Transfer of {self.file!r} postponed after the user decided what to do."
+        )
+
+
+def dt_upload(self: "Remote", transfer: Transfer, **kwargs: Any) -> None:
+    """Upload a given file to the given folderish document on the server.
+
+    Note about possible duplicate creation via a race condition client <-> server.
+    Given the local *file* with the path "$HOME/some-folder/subfolder/file.odt",
+    the file name is "file.odt".
+
+    Scenario:
+        - Step 1: local, check for a doc with the path name "file.odt" => nothing returned, continuing;
+        - Step 2: server, a document with a path name set to "file.odt" is created;
+        - Step 3: local, create the document with the path name "file.odt".
+
+    Even if the elapsed time between steps 1 and 3 is really short, it may happen.
+
+    What can be done to prevent such scenario is not on the Nuxeo Drive side but on the server one.
+    For now, 2 options are possible but not qualified to be done in a near future:
+        - https://jira.nuxeo.com/browse/NXP-22959;
+        - create a new operation `Document.GetOrCreate` that ensures atomicity.
+
+    About kwargs, it is typically used to forward the chunk callback.
+    """
+    local_path = transfer.local_path
+    remote_path = transfer.remote_path
+    name = local_path.name
+    doc: Optional[Document] = None
+
+    log.info(
+        f"Direct Transfer of {local_path!r} into {remote_path!r} (replace_blob={transfer.replace_blob})"
+    )
+
+    if transfer.remote_ref:
+        # The remote ref is set, so it means either the file has already been uploaded,
+        # either a previous upload failed: the document was created, or not, and it has
+        # a blob attached, or not. In any cases, we need to ensure the user can upload
+        # without headhache.
+        doc = self.get_document_or_none(uid=transfer.remote_ref)
+
+    if not doc:
+        # We need to handle possbile duplicates based on the file name and
+        # the destination folder on the server.
+        # Note: using this way may still result in duplicates:
+        #  - the user created 2 documents with the same name on Web-UI or another way
+        #  - the user then deleted the 1st document
+        #  - the other document has a path like "name.TIMESTAMP"
+        # So then Drive will not see that document as a duplicate because it will check
+        # a path with "name" only.
+
+        # If we really want to avoid that situation, we should use that commented code:
+        """
+        # Note that it would be too much effort for the server, we do not want that!
+        for child in self.documents.get_children(path=parent_path):
+            # It is OK to have a folder and a file with the same name,
+            # but not 2 files or 2 folders with the same name
+            if child.title == file.name:
+                local_is_dir = file.isdir()
+                remote_is_dir = "Folderish" in child["facets"]
+                if local_is_dir is remote_is_dir:
+                    # Duplicate found!
+                    doc = child
+                    transfer.remote_ref = doc.uid
+                    break
+        """
+
+        doc = self.get_document_or_none(path=f"{remote_path}/{name}")
+        if doc:
+            transfer.remote_ref = doc.uid
+
+    if not transfer.replace_blob and doc and doc.properties.get("file:content"):
+        # The document already exists and has a blob attached. Ask the user what to do.
+        raise DirectTransferDuplicateFoundError(local_path, doc)
+
+    if not doc:
+        # Create the document on the server
+        nature = "File" if transfer.is_file else "Folder"
+        transfer.doctype = nature
+        doc = self.documents.create(
+            Document(name=name, type=nature, properties={"dc:title": name}),
+            parent_path=remote_path,
+        )
+        transfer.remote_ref = doc.uid
+
+    if not transfer.is_file:
+        transfer.uploaded = True
+        transfer.status = TransferStatus.DONE  # type: ignore
+
+    transfer.save()
+
+    if transfer.is_file:
+        # Upload the blob and attach it to the document
+        self.dt_do_upload(self, transfer, **kwargs)
+
+
+def dt_do_upload(self: "Remote", transfer: Transfer, **kwargs: Any) -> None:
+    """Upload a file with a batch.
+
+    If an exception happens at step 1 or 2, the upload will be continued the next
+    time the Processor handle the document (it will be postponed due to the error).
+
+    If the error was raised at step 1, the upload will not start from zero: it will
+    resume from the next chunk based on what previously chunks were sent.
+    This is dependent of the chunk TTL configured on the server (it must be large enough
+    to handle big files).
+
+    If the error was raised at step 2, the step 1 will be checked to ensure the blob
+    was successfully uploaded. But it most cases, nothing will be uploaded twice.
+    Also, it the error is one of HTTP 502 or 503, the Processor will check for
+    the file existence to bypass errors happening *after* the operation was successful.
+    If it exists, the error is skipped and the upload is seen as a success.
+    """
+    # Step 1: upload the blob
+    blob = self.dt_upload_chunks(self, transfer, **kwargs)
+
+    # Step 2: link the uploaded blob to the document
+    self.dt_link_blob_to_doc(self, transfer, blob)
+
+    # Transfer is completed, delete the upload from the database
+    transfer.status = TransferStatus.DONE  # type: ignore
+    transfer.save()
+
+
+def dt_upload_chunks(self: "Remote", transfer: Transfer, **kwargs: Any) -> FileBlob:
+    """Upload a blob by chunks or in one go."""
+
+    blob = FileBlob(str(transfer.local_path))
+    blob.name = transfer.local_path.name
+
+    # The upload was already done, no need to make useless calls to the server
+    if transfer.uploaded:
+        # Set those attributes as FileBlob does not have them
+        # and they are required for the step 2 of .dt_do_upload()
+        blob.batch_id = transfer.batch.uid
+        blob.fileIdx = transfer.batch.upload_idx
+        return blob
+
+    chunk_size = 0
+
+    # Check if the associated batch still exists server-side
+    if transfer.batch.uid:
+        # When fetching for an eventual batch, specifying the file index
+        # is not possible for S3 as there is no blob at the current index
+        # until the S3 upload is done itself and the call to
+        # batch.complete() done.
+        file_idx = None if transfer.batch.is_s3() else transfer.batch.upload_idx
+
+        try:
+            self.uploads.get(transfer.batch.uid, file_idx=file_idx)
+        except Exception:
+            transfer.batch.uid = None
+            log.debug(f"No associated batch found, restarting from zero", exc_info=True)
+        else:
+            log.debug(f"Associated batch found, resuming the upload")
+            transfer.batch.service = self.uploads
+            chunk_size = transfer.chunk_size
+
+    if not transfer.batch.uid:
+        # .uploads.handlers() result is cached, so it is convenient to call it each time here
+        # in case the server did not answer correctly the previous time and thus S3 would
+        # be completely disabled because of a one-time server error.
+        handler = "s3" if self.uploads.has_s3() else ""
+
+        # Create a new batch and save it in the DB
+        transfer.batch = self.uploads.batch(handler=handler)
+        transfer.save()
+
+    # Set those attributes as FileBlob does not have them
+    # and they are required for the step 2 of .dt_do_upload()
+    blob.batch_id = transfer.batch.uid
+    blob.fileIdx = transfer.batch.upload_idx
+
+    # By default, Options.chunk_size is 20, so chunks will be 20MiB.
+    # It can be set to a value between 1 and 20 through the config.ini
+    chunk_size = chunk_size or (Options.chunk_size * 1024 * 1024)
+
+    # For the upload to be chunked, the Options.chunk_upload must be True
+    # and the blob must be bigger than Options.chunk_limit, which by default
+    # is equal to Options.chunk_size.
+    chunked = Options.chunk_upload and blob.size > Options.chunk_limit * 1024 * 1024
+
+    try:
+        uploader: Uploader = transfer.batch.get_uploader(
+            blob,
+            chunked=chunked,
+            chunk_size=chunk_size,
+            callback=kwargs.get("chunk_callback", None),
+        )
+        log.debug(f"Using {type(uploader).__name__!r} uploader")
+
+        transfer.chunk_size = uploader.chunk_size
+
+        if uploader.chunked:
+            for up in uploader.iter_upload():
+                # Save the progression
+                transfer.uploaded_size = up.blob.uploadedSize
+
+                # Handle status changes every time a chunk is sent
+                if transfer.status not in (TransferStatus.ONGOING, TransferStatus.DONE):
+                    raise DirectTransferPaused(transfer.id)
+
+        else:
+            uploader.upload()
+            transfer.uploaded_size = blob.size
+
+        if transfer.batch.is_s3():
+            # Complete the S3 upload
+            transfer.batch.complete()
+
+        transfer.uploaded = True
+        transfer.batch.upload_idx = 0
+        transfer.save()
+
+        return blob
+    finally:
+        if blob.fd:
+            blob.fd.close()
+
+
+def dt_link_blob_to_doc(self: "Remote", transfer: Transfer, blob: FileBlob) -> None:
+    """Link the given uploaded *blob* to the given document.
+    The method exists only to be able to test upload errors.
+    """
+    try:
+        self.execute(
+            command="Blob.AttachOnDocument",
+            input_obj=blob,
+            headers={"Nuxeo-Transaction-Timeout": str(TX_TIMEOUT)},
+            timeout=TX_TIMEOUT,
+            xpath="file:content",
+            void_op=True,
+            document=transfer.remote_ref,
+        )
+    except HTTPError as exc:
+        if exc.status in (502, 503):
+            # As seen with NXDRIVE-1753, an uploaded file may have worked
+            # but for some reason the final state is in error. So, let's
+            # check if the document is present on the server to bypass
+            # (infinite|useless) retries.
+            if self.get_document_or_none(uid=transfer.remote_ref):
+                return
+        raise
diff --git a/nxdrive/engine/dao/sqlite.py b/nxdrive/engine/dao/sqlite.py
index 5678fcded..aacf22797 100644
--- a/nxdrive/engine/dao/sqlite.py
+++ b/nxdrive/engine/dao/sqlite.py
@@ -112,9 +112,6 @@
     ("unsynchronized", "moved"): "unsynchronized",
     ("unsynchronized", "synchronized"): "unsynchronized",
     ("unsynchronized", "deleted"): "remotely_deleted",
-    # Direct Transfer
-    ("direct", "unknown"): "direct_transfer",
-    ("direct", "deleted"): "direct_transfer_replace_blob",
 }
 
 
@@ -717,7 +714,6 @@ def _migrate_db(self, cursor: Cursor, version: int) -> None:
 
             # Delete the table
             cursor.execute("DROP TABLE Uploads_backup;")
-
             self.store_int(SCHEMA_VERSION, 7)
 
     def _create_table(self, cursor: Cursor, name: str, force: bool = False) -> None:
@@ -1176,21 +1172,6 @@ def update_local_modification_time(self, row: DocPair, info: FileInfo) -> None:
                 (info.last_modification_time, row.id),
             )
 
-    def update_pair_state(self, row: DocPair) -> None:
-        """Update local, remote and pair states of a given *doc_pair*.
-        States should already be defined in the *doc_pair* attributes,
-        the goal is only to save them in the database.
-        """
-        row.pair_state = self._get_pair_state(row)
-
-        with self.lock:
-            con = self._get_write_connection()
-            c = con.cursor()
-            c.execute(
-                "UPDATE States SET local_state = ?, remote_state = ?, pair_state = ? WHERE id = ?",
-                (row.local_state, row.remote_state, row.pair_state, row.id),
-            )
-
     def get_valid_duplicate_file(self, digest: str) -> Optional[DocPair]:
         """Find a file already synced with the same digest as the given *digest*."""
         c = self._get_read_connection().cursor()
diff --git a/nxdrive/engine/engine.py b/nxdrive/engine/engine.py
index b6b3ac74e..cf4be9003 100644
--- a/nxdrive/engine/engine.py
+++ b/nxdrive/engine/engine.py
@@ -28,6 +28,7 @@
     DelAction,
     TransferStatus,
 )
+from ..direct_transfer import DirectTransferManager
 from ..exceptions import (
     EngineInitError,
     InvalidDriveException,
@@ -41,7 +42,6 @@
     current_thread_id,
     find_icon,
     find_suitable_tmp_dir,
-    get_tree_list,
     if_frozen,
     safe_filename,
     set_path_readonly,
@@ -56,6 +56,7 @@
 from .workers import Worker
 
 if TYPE_CHECKING:
+    from ..direct_transfer import DirectTransferManager  # noqa
     from ..manager import Manager  # noqa
 
 __all__ = ("Engine", "ServerBindingSettings")
@@ -101,9 +102,8 @@ class Engine(QObject):
     online = pyqtSignal()
 
     # Direct Transfer
-    directTranferDuplicateError = pyqtSignal(Path, Document)
+    directTransferDuplicateError = pyqtSignal(Path, Document)
     directTranferError = pyqtSignal(Path)
-    directTranferStatus = pyqtSignal(Path, bool)
 
     type = "NXDRIVE"
     # Folder locker - LocalFolder processor can prevent
@@ -216,6 +216,19 @@ def __init__(
         # Pause in case of no more space on the device
         self.noSpaceLeftOnDevice.connect(self.suspend)
 
+        # Set the Direct Transfer database file
+        db = self.manager.home / "direct_transfer" / f"{self.uid}.db"
+        db.parent.mkdir(exist_ok=True)
+
+        # And create the Direct Transfer manager
+        self.dt_manager = DirectTransferManager(
+            str(db),
+            self.uid,
+            self.remote,
+            done_callback=self.manager.directTransferStats.emit,
+            dupe_callback=self.directTransferDuplicateError.emit,
+        )
+
     def __repr__(self) -> str:
         return (
             f"<{type(self).__name__} "
@@ -388,70 +401,32 @@ def delete_doc(self, path: Path, mode: DelAction = None) -> None:
                     f"{doc_pair.remote_parent_path}/{doc_pair.remote_ref}"
                 )
 
-    def direct_transfer(self, local_paths: Set[Path], remote_ref: str) -> None:
+    def direct_transfer(
+        self, local_paths: Set[Path], remote_path: str, start: bool = True
+    ) -> None:
         """Plan the Direct Transfer."""
-        # self.directTranferStatus.emit(local_path[0], True)
-
-        def plan(path: Path, remote_uid: str) -> None:
-            """Actions to do (refactored in a function to prevent duplicate code between files and folders)."""
-            # Save the remote folder's reference into the file/folder xattrs
-            try:
-                self.local.set_remote_id(path, remote_uid)
-            except PermissionError:
-                log.warning(
-                    f"Cannot set the remote ID on {path!r}, skipping the upload"
-                )
-                return
-
-            # Add the path into the database to plan the upload
-            info = self.local.get_info(path, check=False)
-            self.dao.insert_local_state(info, parent_path=None, local_state="direct")
-
         # Save the remote location for next times
-        self.dao.update_config("dt_last_remote_location", remote_ref)
+        self.dao.update_config("dt_last_remote_location", remote_path)
 
-        for local_path in sorted(local_paths):
-            if local_path.is_file():
-                plan(local_path, remote_ref)
-            else:
-                tree = sorted(get_tree_list(local_path, remote_ref))
-                for remote_path, path in tree:
-                    plan(path, remote_path)
+        if self.dt_manager.is_completed:
+            # Create a new transfers session
+            self.dt_manager.reset()
+
+        # Add paths recursively and start uploading!
+        if local_paths:
+            self.dt_manager.add_all(local_paths, remote_path)
+            if start:
+                self.dt_manager.start()
 
     def direct_transfer_cancel(self, file: Path) -> None:
         """Cancel the Direct Transfer of the given local *file*."""
-        log.info(f"Direct Transfer of {file!r}, user choice: cancel the upload")
-
-        doc_pair = self.dao.get_state_from_local(file)
-        if not doc_pair:
-            # Magic teleportation?
-            log.warning("The doc pair disappeared?! Direct Transfer cancelled.")
-            return
-
-        # Cancel the upload, clean-up the database and local file
-        self.dao.remove_state(doc_pair)
-        self.local.remove_remote_id(file)
-        self.local.remove_remote_id(file, name="remote")
+        if self.dt_manager:
+            self.dt_manager.cancel(file)
 
     def direct_transfer_replace_blob(self, file: Path, doc: Document) -> None:
         """Replace the document's blob on the server."""
-        log.info(
-            f"Direct Transfer of {file!r}, user choice: "
-            f"replace the document's attached file (UID is {doc.uid!r})"
-        )
-
-        doc_pair = self.dao.get_state_from_local(file)
-        if not doc_pair:
-            # Magic teleportation?
-            log.warning("The doc pair disappeared?! Direct Transfer cancelled.")
-            return
-
-        # Plan the replacement of the document's blob on the server
-        doc_pair.remote_state = "deleted"
-        self.dao.update_pair_state(doc_pair)
-
-        # Repush the pair to be traited later
-        self.queue_manager.push(doc_pair)
+        if self.dt_manager:
+            self.dt_manager.replace_blob(file, doc.uid)
 
     def rollback_delete(self, path: Path) -> None:
         """ Re-synchronize a document when a deletion is cancelled. """
@@ -543,6 +518,8 @@ def resume(self) -> None:
             else:
                 thread.start()
         self.resume_suspended_transfers()
+        if self.dt_manager:
+            self.dt_manager.start()
         self.syncResumed.emit()
 
     def resume_transfer(self, nature: str, uid: int) -> None:
@@ -590,6 +567,8 @@ def suspend(self) -> None:
         log.info(f"Engine {self.uid} is suspending")
         self._pause = True
         self.dao.suspend_transfers()
+        if self.dt_manager:
+            self.dt_manager.stop()
         self.queue_manager.suspend()
         for thread in self._threads:
             thread.worker.suspend()
diff --git a/nxdrive/engine/processor.py b/nxdrive/engine/processor.py
index e859418c5..8f3b75f8a 100644
--- a/nxdrive/engine/processor.py
+++ b/nxdrive/engine/processor.py
@@ -31,7 +31,6 @@
     TransferStatus,
 )
 from ..exceptions import (
-    DirectTransferDuplicateFoundError,
     DownloadPaused,
     DuplicationDisabledError,
     NotFound,
@@ -42,7 +41,6 @@
     UploadPaused,
 )
 from ..objects import DocPair, RemoteFileInfo
-from ..options import Options
 from ..utils import is_generated_tmp_file, lock_path, safe_filename, unlock_path
 from .workers import EngineWorker
 
@@ -312,16 +310,11 @@ def _execute(self) -> None:
                 self._postpone_pair(doc_pair, "MAX_RETRY_ERROR")
             except HTTPError as exc:
                 if exc.status == 404:
-                    if doc_pair.local_state == "direct":
-                        # Happening while Direct Transfer'ring a document,
-                        # that means the parent folder is not yet created. Postpone.
-                        self._postpone_pair(doc_pair, "Parent not yet synced")
-                    else:
-                        # We saw it happened once a migration is done.
-                        # Nuxeo kept the document reference but it does
-                        # not exist physically anywhere.
-                        log.info(f"The document does not exist anymore: {doc_pair!r}")
-                        self.dao.remove_state(doc_pair)
+                    # We saw it happened once a migration is done.
+                    # Nuxeo kept the document reference but it does
+                    # not exist physically anywhere.
+                    log.info(f"The document does not exist anymore: {doc_pair!r}")
+                    self.dao.remove_state(doc_pair)
                 elif exc.status == 409:  # Conflict
                     # It could happen on multiple files drag'n drop
                     # starting with identical characters.
@@ -391,23 +384,9 @@ def _execute(self) -> None:
                     self._postpone_pair(doc_pair, "Trashing not possible")
                 else:
                     self._handle_pair_handler_exception(doc_pair, handler_name, exc)
-            except DirectTransferDuplicateFoundError as exc:
-                # Ask the user what to do when a possible duplicate can be created by a Direct Transfer call
-                log.info(str(exc))
-                self.engine.directTranferDuplicateError.emit(exc.file, exc.doc)
             except Exception as exc:
                 # Workaround to forward unhandled exceptions to sys.excepthook between all Qthreads
                 sys.excepthook(*sys.exc_info())
-
-                # Show a notification for Direct Transfer errors
-                if doc_pair.pair_state.startswith("direct_transfer"):
-                    file = (
-                        doc_pair.local_path
-                        if WINDOWS
-                        else Path(f"/{doc_pair.local_path}")
-                    )
-                    self.engine.directTranferError.emit(file)
-
                 self._handle_pair_handler_exception(doc_pair, handler_name, exc)
             finally:
                 if soft_lock:
@@ -474,56 +453,6 @@ def _handle_pair_handler_exception(
             log.exception("Unknown error")
             self.increase_error(doc_pair, f"SYNC_HANDLER_{handler_name}", exception=e)
 
-    def _synchronize_direct_transfer(
-        self, doc_pair: DocPair, replace_blob: bool = False
-    ) -> None:
-        """Direct Transfer of a local file."""
-        if WINDOWS:
-            file = doc_pair.local_path
-        else:
-            # The path retrieved from the database will have its starting slash trimmed, restore it
-            file = Path(f"/{doc_pair.local_path}")
-
-        if not file.exists():
-            self.engine.directTranferError.emit(file)
-            log.warning(
-                f"Cancelling Direct Transfer of {file!r} because it does not exist anymore"
-            )
-            self.dao.remove_state(doc_pair)
-            self.dao.remove_transfer("upload", file)
-            return
-
-        # The remote path is stored as the remote ref in xattrs of the file
-        parent_path = self.local.get_remote_id(file)
-        if not parent_path:
-            self.engine.directTranferError.emit(file)
-            log.warning(
-                f"Cancelling Direct Transfer of {file!r} because it has no remote path set"
-            )
-            self.dao.remove_state(doc_pair)
-            self.dao.remove_transfer("upload", file)
-            return
-
-        # Do the upload
-        self.remote.direct_transfer(
-            file, parent_path, self.engine.uid, replace_blob=replace_blob
-        )
-
-        # Clean-up
-        self.dao.remove_state(doc_pair)
-        self.local.remove_remote_id(file)
-        self.local.remove_remote_id(file, name="remote")
-
-        # Display a notification only for big files (to prevent notifications flood)
-        if not doc_pair.folderish and doc_pair.size >= Options.big_file * 1024 * 1024:
-            self.engine.directTranferStatus.emit(file, False)
-
-        self.engine.manager.directTransferStats.emit(doc_pair.folderish, doc_pair.size)
-
-    def _synchronize_direct_transfer_replace_blob(self, doc_pair: DocPair) -> None:
-        """Force the blob replacement of the remote document (choice done by the user)."""
-        self._synchronize_direct_transfer(doc_pair, replace_blob=True)
-
     def _synchronize_conflicted(self, doc_pair: DocPair) -> None:
         if doc_pair.local_state == "moved" and doc_pair.remote_state in (
             "moved",
diff --git a/nxdrive/engine/queue_manager.py b/nxdrive/engine/queue_manager.py
index 8a692c6b7..2b24553de 100644
--- a/nxdrive/engine/queue_manager.py
+++ b/nxdrive/engine/queue_manager.py
@@ -208,13 +208,6 @@ def push(self, state: Union[DocPair, QueueItem]) -> None:
                     f"{self._remote_file_queue.qsize()}"
                 )
             self.newItem.emit(row_id)
-        elif state.pair_state.startswith("direct_transfer"):
-            self._local_file_queue.put(state)
-            log.debug(
-                "Pushed to _local_file_queue, now of size: "
-                f"{self._local_file_queue.qsize()}"
-            )
-            self.newItem.emit(row_id)
         else:
             # deleted and conflicted
             log.info(f"Not processable state: {state!r}")
diff --git a/nxdrive/exceptions.py b/nxdrive/exceptions.py
index c50855a22..cd0aca37e 100644
--- a/nxdrive/exceptions.py
+++ b/nxdrive/exceptions.py
@@ -1,9 +1,6 @@
 # coding: utf-8
-from pathlib import Path
 from typing import TYPE_CHECKING, Any
 
-from nuxeo.models import Document
-
 if TYPE_CHECKING:
     from .engine.engine import Engine  # noqa
 
@@ -14,26 +11,6 @@ class DriveError(Exception):
     pass
 
 
-class DirectTransferDuplicateFoundError(ValueError):
-    """
-    Exception raised when a duplicate file already exists on the server
-    and trying to Direct Transfer a local file with the same name.
-    """
-
-    def __init__(self, file: Path, doc: Document) -> None:
-        self.file = file
-        self.doc = doc
-
-    def __repr__(self) -> str:
-        return (
-            f"Document with the name {self.file.name!r} already found on the server: {self.doc}."
-            f"Direct Transfer of {self.file!r} postponed after the user decided what to do."
-        )
-
-    def __str__(self) -> str:
-        return repr(self)
-
-
 class DocumentAlreadyLocked(DriveError):
     """ In DirectEdit, a document is locked by someone else. """
 
diff --git a/nxdrive/gui/application.py b/nxdrive/gui/application.py
index 4ef6e4b88..d86afd665 100644
--- a/nxdrive/gui/application.py
+++ b/nxdrive/gui/application.py
@@ -45,6 +45,7 @@
 from ..gui.folders_dialog import DialogMixin, DocumentsDialog, FoldersDialog
 from ..notification import Notification
 from ..options import Options
+from ..state import State
 from ..translator import Translator
 from ..updater.constants import (
     UPDATE_STATUS_INCOMPATIBLE_SERVER,
@@ -202,6 +203,12 @@ def __init__(self, manager: "Manager", *args: Any) -> None:
         if Options.protocol_url:
             self._handle_nxdrive_url(Options.protocol_url)
 
+    @pyqtSlot()
+    def exit_app(self) -> None:
+        """Initiate the application exit."""
+        State.about_to_quit = True
+        self.quit()
+
     @if_frozen
     def add_qml_import_path(self, view: QQuickView) -> None:
         """
@@ -828,7 +835,7 @@ def auth() -> None:
 
     @pyqtSlot(object)
     def _connect_engine(self, engine: Engine) -> None:
-        engine.directTranferDuplicateError.connect(
+        engine.directTransferDuplicateError.connect(
             self._direct_transfer_duplicate_error
         )
         engine.syncStarted.connect(self.change_systray_icon)
diff --git a/nxdrive/gui/systray.py b/nxdrive/gui/systray.py
index c31e9790c..9493bfca9 100644
--- a/nxdrive/gui/systray.py
+++ b/nxdrive/gui/systray.py
@@ -79,7 +79,7 @@ def get_context_menu(self) -> QMenu:
         menu.addAction(
             style.standardIcon(QStyle.SP_DialogCloseButton),
             Translator.get("QUIT"),
-            self.application.quit,
+            self.application.exit_app,
         )
 
         return menu
diff --git a/nxdrive/logging_config.py b/nxdrive/logging_config.py
index d8c7c5885..549e61085 100644
--- a/nxdrive/logging_config.py
+++ b/nxdrive/logging_config.py
@@ -193,6 +193,9 @@ def configure(
     # NXDRIVE-1918: filter out botocore logging (too verbose)
     logging.getLogger("botocore").setLevel(logging.ERROR)
 
+    # NXDRIVE-2006: filter out peewee logging (too verbose)
+    logging.getLogger("peewee").setLevel(logging.ERROR)
+
 
 def get_handler(name: str) -> Optional[logging.Handler]:
     for handler in logging.getLogger().handlers:
diff --git a/nxdrive/manager.py b/nxdrive/manager.py
index 00f5f856c..85341a0de 100644
--- a/nxdrive/manager.py
+++ b/nxdrive/manager.py
@@ -369,6 +369,7 @@ def stop(self, euid: str = None) -> None:
                 continue
             if engine.is_started():
                 engine.stop()
+            engine.dt_manager.shutdown()
         self.osi.cleanup()
         self.dispose_db()
         self.stopped.emit()
